<?php
/**
 * NGO Charity Donation functions and definitions
 *
 * @subpackage NGO Charity Donation
 * @since 1.0
 */

// theme setup
function ngo_charity_donation_setup() {
	add_theme_support( 'woocommerce' );
	add_theme_support( "align-wide" );
	add_theme_support( "wp-block-styles" );
	add_theme_support( 'automatic-feed-links' );
	add_theme_support( 'post-thumbnails' );
	add_theme_support( "responsive-embeds" );
	add_theme_support( 'title-tag' );
	add_theme_support('custom-background',array(
		'default-color' => 'ffffff',
	));
	add_image_size( 'ngo-charity-donation-featured-image', 2000, 1200, true );
	add_image_size( 'ngo-charity-donation-thumbnail-avatar', 100, 100, true );

	load_theme_textdomain( 'ngo-charity-donation', get_template_directory() . '/languages' );

	$GLOBALS['content_width'] = 525;
	register_nav_menus( array(
		'primary' => __( 'Primary Menu', 'ngo-charity-donation' ),
	) );

	add_theme_support( 'html5', array(
		'comment-form',
		'comment-list',
		'gallery',
		'caption',
	) );

	// Add theme support for Custom Logo.
	add_theme_support( 'custom-logo', array(
		'width'       => 250,
		'height'      => 250,
		'flex-width'  => true,
		'flex-height' => true,
	) );

	// Add theme support for selective refresh for widgets.
	add_theme_support( 'customize-selective-refresh-widgets' );
	/*
	 * Enable support for Post Formats.
	 *
	 * See: https://codex.wordpress.org/Post_Formats
	 */
	add_theme_support( 'post-formats', array('image','video','gallery','audio','quote',) );
	/*
	 * This theme styles the visual editor to resemble the theme style,
	 * specifically font, colors, and column width.
 	 */
	add_editor_style( array( 'assets/css/editor-style.css', ngo_charity_donation_fonts_url() ) );

	if ( ! defined( 'NGO_CHARITY_DONATION_SUPPORT' ) ) {
	define('NGO_CHARITY_DONATION_SUPPORT',__('https://wordpress.org/support/theme/ngo-charity-donation/','ngo-charity-donation'));
	}
	if ( ! defined( 'NGO_CHARITY_DONATION_REVIEW' ) ) {
	define('NGO_CHARITY_DONATION_REVIEW',__('https://wordpress.org/support/theme/ngo-charity-donation/reviews/','ngo-charity-donation'));
	}
	if ( ! defined( 'NGO_CHARITY_DONATION_LIVE_DEMO' ) ) {
	define('NGO_CHARITY_DONATION_LIVE_DEMO',__('https://trial.ovationthemes.com/ngo-charity-donation/','ngo-charity-donation'));
	}
	if ( ! defined( 'NGO_CHARITY_DONATION_BUY_PRO' ) ) {
	define('NGO_CHARITY_DONATION_BUY_PRO',__('https://www.ovationthemes.com/products/ngo-charity-wordpress-theme','ngo-charity-donation'));
	}
	if ( ! defined( 'NGO_CHARITY_DONATION_PRO_DOC' ) ) {
	define('NGO_CHARITY_DONATION_PRO_DOC',__('https://trial.ovationthemes.com/docs/ot-ngo-charity-pro-doc/','ngo-charity-donation'));
	}
	if ( ! defined( 'NGO_CHARITY_DONATION_FREE_DOC' ) ) {
	define('NGO_CHARITY_DONATION_FREE_DOC',__('https://trial.ovationthemes.com/docs/ot-ngo-charity-donation-free-doc/','ngo-charity-donation'));
	}
	if ( ! defined( 'NGO_CHARITY_DONATION_THEME_NAME' ) ) {
	define('NGO_CHARITY_DONATION_THEME_NAME',__('Premium NGO Charity Theme','ngo-charity-donation'));
	}
	if ( ! defined( 'NGO_CHARITY_DONATION_BUNDLE_LINK' ) ) {
	define('NGO_CHARITY_DONATION_BUNDLE_LINK',__('https://www.ovationthemes.com/products/wordpress-bundle','ngo-charity-donation'));
	}
	require get_template_directory() . '/inc/dashboard/dashboard-settings.php';
	require get_template_directory() . '/inc/admin/theme-upsell.php';

}
add_action( 'after_setup_theme', 'ngo_charity_donation_setup' );

//woocommerce//
//shop page no of columns
function ngo_charity_donation_woocommerce_loop_columns() {
	
	$retrun = get_theme_mod( 'ngo_charity_donation_archieve_item_columns', 3 );
    
    return $retrun;
}
add_filter( 'loop_shop_columns', 'ngo_charity_donation_woocommerce_loop_columns' );
function ngo_charity_donation_woocommerce_products_per_page() {

		$retrun = get_theme_mod( 'ngo_charity_donation_archieve_shop_perpage', 6 );
    
    return $retrun;
}
add_filter( 'loop_shop_per_page', 'ngo_charity_donation_woocommerce_products_per_page' );
// related products
function ngo_charity_donation_related_products_args( $args ) {
    $defaults = array(
        'posts_per_page' => get_theme_mod( 'ngo_charity_donation_related_shop_perpage', 3 ),
        'columns'        => get_theme_mod( 'ngo_charity_donation_related_item_columns', 3),
    );

    $args = wp_parse_args( $defaults, $args );

    return $args;
}
add_filter( 'woocommerce_output_related_products_args', 'ngo_charity_donation_related_products_args' );

// breadcrumb seperator
function ngo_charity_donation_woocommerce_breadcrumb_separator($ngo_charity_donation_defaults) {
    $ngo_charity_donation_separator = get_theme_mod('woocommerce_breadcrumb_separator', ' / ');

    // Update the separator
    $ngo_charity_donation_defaults['delimiter'] = $ngo_charity_donation_separator;

    return $ngo_charity_donation_defaults;
}
add_filter('woocommerce_breadcrumb_defaults', 'ngo_charity_donation_woocommerce_breadcrumb_separator');

//add animation class
if ( class_exists( 'WooCommerce' ) ) { 
	add_filter('post_class', function($ngo_charity_donation_classes, $class, $product_id) {
	    if( is_shop() || is_product_category() ){
	        
	        $ngo_charity_donation_classes = array_merge(['wow','zoomIn'], $ngo_charity_donation_classes);
	    }
	    return $ngo_charity_donation_classes;
	},10,3);
}
//woocommerce-end//


function ngo_charity_donation_excerpt_enabled(){
	if(get_theme_mod('ngo_charity_donation_blog_meta_content') == 'Excerpt Content' ) {
		return true;
	}
	return false;
}

/* Excerpt Limit Begin */
function ngo_charity_donation_string_limit_words($string, $word_limit) {
	$words = explode(' ', $string, ($word_limit + 1));
	if(count($words) > $word_limit)
	array_pop($words);
	return implode(' ', $words);
}

// Admin scripts and styles
function ngo_charity_donation_enqueue_admin_script( $hook ) {
	wp_enqueue_style(
		'ngo-charity-donation-admin-style',
		get_template_directory_uri() . '/assets/css/admin-style.css'
	);
	wp_enqueue_script(
		'ngo-charity-donation-admin-js',
		get_theme_file_uri( '/assets/js/ngo-charity-donation-admin.js' ),
		array( 'jquery' ),
		'1.0.0',
		true
	);
	wp_localize_script(
		'ngo-charity-donation-admin-js',
		'ngo_charity_donation_localize',
		array(
			'ajax_url'      => admin_url( 'admin-ajax.php' ),
			'nonce'         => wp_create_nonce( 'ngo_charity_donation_dismissed_notice_nonce' ),
			'dismiss_nonce' => wp_create_nonce( 'ngo_charity_donation_dismissed_notice_nonce' ),
		)
	);
}
add_action( 'admin_enqueue_scripts', 'ngo_charity_donation_enqueue_admin_script' );

// tag count
function ngo_charity_donation_display_post_tag_count() {
    $ngo_charity_donation_tags = get_the_tags();
    $ngo_charity_donation_tag_count = ($ngo_charity_donation_tags) ? count($ngo_charity_donation_tags) : 0;
    $ngo_charity_donation_tag_text = ($ngo_charity_donation_tag_count === 1) ? 'tag' : 'tags';
    echo $ngo_charity_donation_tag_count . ' ' . $ngo_charity_donation_tag_text;
}

// Date formatting
function ngo_charity_donation_display_shop_date() {
    // Get the date type option
    $ngo_charity_donation_date_type = get_theme_mod( 'ngo_charity_donation_date_type', 'published' );

    // Determine the date to display based on the type
    if ( $ngo_charity_donation_date_type === 'modified' && get_the_modified_time( 'U' ) !== get_the_time( 'U' ) ) {
        $ngo_charity_donation_date_to_display = get_the_modified_date( get_option( 'date_format' ) );
    } else {
        $ngo_charity_donation_date_to_display = get_the_date( get_option( 'date_format' ) );
    }

    // Output the date HTML

    echo esc_html( $ngo_charity_donation_date_to_display );
}

//media post format
function ngo_charity_donation_get_media($ngo_charity_donation_type = array()){
	$ngo_charity_donation_content = apply_filters( 'the_content', get_the_content() );
  	$output = false;

  // Only get media from the content if a playlist isn't present.
  if ( false === strpos( $ngo_charity_donation_content, 'wp-playlist-script' ) ) {
    $output = get_media_embedded_in_content( $ngo_charity_donation_content, $ngo_charity_donation_type );
    return $output;
  }
}

// front page template
function ngo_charity_donation_front_page_template( $template ) {
	return is_home() ? '' : $template;
}
add_filter( 'frontpage_template',  'ngo_charity_donation_front_page_template' );

// excerpt function
function ngo_charity_donation_custom_excerpt() {
    $ngo_charity_donation_excerpt = get_the_excerpt();
    $ngo_charity_donation_plain_text_excerpt = wp_strip_all_tags($ngo_charity_donation_excerpt);
    
    // Get dynamic word limit from theme mod
    $ngo_charity_donation_word_limit = esc_attr(get_theme_mod('ngo_charity_donation_post_excerpt', '30'));
    
    // Limit the number of words
    $ngo_charity_donation_limited_excerpt = implode(' ', array_slice(explode(' ', $ngo_charity_donation_plain_text_excerpt), 0, $ngo_charity_donation_word_limit));

    echo esc_html($ngo_charity_donation_limited_excerpt);
}

// typography
function ngo_charity_donation_fonts_scripts() {
	$ngo_charity_donation_headings_font = esc_html(get_theme_mod('ngo_charity_donation_headings_text'));
	$ngo_charity_donation_body_font = esc_html(get_theme_mod('ngo_charity_donation_body_text'));

	if( $ngo_charity_donation_headings_font ) {
		wp_enqueue_style( 'ngo-charity-donation-headings-fonts', '//fonts.googleapis.com/css?family='. $ngo_charity_donation_headings_font );
	} else {
		wp_enqueue_style( 'ngo-charity-donation-source-sans', '//fonts.googleapis.com/css?family=Lato:400,700,400italic,700italic');
	}
	if( $ngo_charity_donation_body_font ) {
		wp_enqueue_style( 'ngo-charity-donation-body-fonts', '//fonts.googleapis.com/css?family='. $ngo_charity_donation_body_font );
	} else {
		wp_enqueue_style( 'ngo-charity-donation-source-body', '//fonts.googleapis.com/css?family=Source+Sans+Pro:400,300,400italic,700,600');
	}
}
add_action( 'wp_enqueue_scripts', 'ngo_charity_donation_fonts_scripts' );

// Footer Text
function ngo_charity_donation_copyright_link() {
    $ngo_charity_donation_footer_text = get_theme_mod('ngo_charity_donation_footer_text', esc_html__('NGO Charity WordPress Theme', 'ngo-charity-donation'));
    $ngo_charity_donation_credit_link = esc_url('https://www.ovationthemes.com/products/free-ngo-charity-wordpress-theme');

    echo '<a href="' . $ngo_charity_donation_credit_link . '" target="_blank">' . esc_html($ngo_charity_donation_footer_text) . '<span class="footer-copyright">' . esc_html__(' By Ovation Themes', 'ngo-charity-donation') . '</span></a>';
}

// custom sanitizations
// dropdown
function ngo_charity_donation_sanitize_dropdown_pages( $page_id, $setting ) {
	$page_id = absint( $page_id );
	return ( 'publish' == get_post_status( $page_id ) ? $page_id : $setting->default );
}
// slider custom control
if ( ! function_exists( 'ngo_charity_donation_sanitize_integer' ) ) {
	function ngo_charity_donation_sanitize_integer( $input ) {
		return (int) $input;
	}
}
// range contol
function ngo_charity_donation_sanitize_number_absint( $number, $setting ) {

	// Ensure input is an absolute integer.
	$number = absint( $number );

	// Get the input attributes associated with the setting.
	$atts = $setting->manager->get_control( $setting->id )->input_attrs;

	// Get minimum number in the range.
	$min = ( isset( $atts['min'] ) ? $atts['min'] : $number );

	// Get maximum number in the range.
	$max = ( isset( $atts['max'] ) ? $atts['max'] : $number );

	// Get step.
	$step = ( isset( $atts['step'] ) ? $atts['step'] : 1 );

	// If the number is within the valid range, return it; otherwise, return the default
	return ( $min <= $number && $number <= $max && is_int( $number / $step ) ? $number : $setting->default );
}
// select post page
function ngo_charity_donation_sanitize_select( $ngo_charity_donation_input, $setting ){
    $ngo_charity_donation_input = sanitize_key($ngo_charity_donation_input);
    $choices = $setting->manager->get_control( $setting->id )->choices;
    return ( array_key_exists( $ngo_charity_donation_input, $choices ) ? $ngo_charity_donation_input : $setting->default );
}
// toggle switch
function ngo_charity_donation_callback_sanitize_switch( $value ) {
	// Switch values must be equal to 1 of off. Off is indicator and should not be translated.
	return ( ( isset( $value ) && $value == 1 ) ? 1 : 'off' );
}
//choices control
function ngo_charity_donation_sanitize_choices( $ngo_charity_donation_input, $setting ) {
    global $wp_customize;
    $control = $wp_customize->get_control( $setting->id );
    if ( array_key_exists( $ngo_charity_donation_input, $control->choices ) ) {
        return $ngo_charity_donation_input;
    } else {
        return $setting->default;
    }
}
// phone number
function ngo_charity_donation_sanitize_phone_number( $phone ) {
  return preg_replace( '/[^\d+]/', '', $phone );
}
// Sanitize Sortable control.
function ngo_charity_donation_sanitize_sortable( $val, $setting ) {
	if ( is_string( $val ) || is_numeric( $val ) ) {
		return array(
			esc_attr( $val ),
		);
	}
	$sanitized_value = array();
	foreach ( $val as $item ) {
		if ( isset( $setting->manager->get_control( $setting->id )->choices[ $item ] ) ) {
			$sanitized_value[] = esc_attr( $item );
		}
	}
	return $sanitized_value;
}

// widgets
function ngo_charity_donation_widgets_init() {
	register_sidebar( array(
		'name'          => __( 'Sidebar', 'ngo-charity-donation' ),
		'id'            => 'sidebar-1',
		'description'   => __( 'Add widgets here to appear in your sidebar on blog posts and archive pages.', 'ngo-charity-donation' ),
		'before_widget' => '<section id="%1$s" class="widget wow zoomIn %2$s">',
		'after_widget'  => '</section>',
		'before_title'  => '<div class="widget_container"><h3 class="widget-title">',
		'after_title'   => '</h3></div>',
	) );

	register_sidebar( array(
		'name'          => __( 'Page Sidebar', 'ngo-charity-donation' ),
		'id'            => 'sidebar-2',
		'description'   => __( 'Add widgets here to appear in your pages and posts', 'ngo-charity-donation' ),
		'before_widget' => '<section id="%1$s" class="widget wow zoomIn %2$s">',
		'after_widget'  => '</section>',
		'before_title'  => '<div class="widget_container"><h3 class="widget-title">',
		'after_title'   => '</h3></div>',
	) );

	register_sidebar( array(
		'name'          => __( 'Sidebar 3', 'ngo-charity-donation' ),
		'id'            => 'sidebar-3',
		'description'   => __( 'Add widgets here to appear in your sidebar on blog posts and archive pages.', 'ngo-charity-donation' ),
		'before_widget' => '<section id="%1$s" class="widget wow zoomIn %2$s">',
		'after_widget'  => '</section>',
		'before_title'  => '<div class="widget_container"><h3 class="widget-title">',
		'after_title'   => '</h3></div>',
	) );
	register_sidebar( array(
		'name'          => __( 'Footer 1', 'ngo-charity-donation' ),
		'id'            => 'footer-1',
		'description'   => __( 'Add widgets here to appear in your footer.', 'ngo-charity-donation' ),
		'before_widget' => '<section id="%1$s" class="widget %2$s">',
		'after_widget'  => '</section>',
		'before_title'  => '<h3 class="widget-title">',
		'after_title'   => '</h3>',
	) );

	register_sidebar( array(
		'name'          => __( 'Footer 2', 'ngo-charity-donation' ),
		'id'            => 'footer-2',
		'description'   => __( 'Add widgets here to appear in your footer.', 'ngo-charity-donation' ),
		'before_widget' => '<section id="%1$s" class="widget %2$s">',
		'after_widget'  => '</section>',
		'before_title'  => '<h3 class="widget-title">',
		'after_title'   => '</h3>',
	) );

	register_sidebar( array(
		'name'          => __( 'Footer 3', 'ngo-charity-donation' ),
		'id'            => 'footer-3',
		'description'   => __( 'Add widgets here to appear in your footer.', 'ngo-charity-donation' ),
		'before_widget' => '<section id="%1$s" class="widget %2$s">',
		'after_widget'  => '</section>',
		'before_title'  => '<h3 class="widget-title">',
		'after_title'   => '</h3>',
	) );

	register_sidebar( array(
		'name'          => __( 'Footer 4', 'ngo-charity-donation' ),
		'id'            => 'footer-4',
		'description'   => __( 'Add widgets here to appear in your footer.', 'ngo-charity-donation' ),
		'before_widget' => '<section id="%1$s" class="widget %2$s">',
		'after_widget'  => '</section>',
		'before_title'  => '<h3 class="widget-title">',
		'after_title'   => '</h3>',
	) );
}
add_action( 'widgets_init', 'ngo_charity_donation_widgets_init' );

// google fonts
function ngo_charity_donation_fonts_url(){
	$font_url = '';
	$font_family = array();
	$font_family[] = 'Inter:wght@100;200;300;400;500;600;700;800;900';
	$font_family[] = 'Outfit:wght@100;200;300;400;500;600;700;800;900';

	$query_args = array(
		'family'	=> rawurlencode(implode('|',$font_family)),
	);
	$font_url = add_query_arg($query_args,'//fonts.googleapis.com/css');
	return $font_url;
	$contents = wptt_get_webfont_url( esc_url_raw( $fonts_url ) );
}

//Enqueue scripts and styles.
function ngo_charity_donation_scripts() {

	// Add custom fonts, used in the main stylesheet.
	wp_enqueue_style( 'ngo-charity-donation-fonts', ngo_charity_donation_fonts_url(), array() );

	//Bootstarp
	wp_enqueue_style( 'bootstrap-style', get_template_directory_uri().'/assets/css/bootstrap.css' );

	// Theme stylesheet.
	wp_enqueue_style( 'ngo-charity-donation-style', get_stylesheet_uri() );

	wp_style_add_data('ngo-charity-donation-style', 'rtl', 'replace');

	// Theme Customize CSS.
	require get_parent_theme_file_path( 'inc/extra_customization.php' );
	wp_add_inline_style( 'ngo-charity-donation-style',$ngo_charity_donation_custom_style );

	//font-awesome
	wp_enqueue_style( 'font-awesome-style', get_template_directory_uri().'/assets/css/fontawesome-all.css' );

	// Block Style
	wp_enqueue_style( 'ngo-charity-donation-block-style', get_template_directory_uri().'/assets/css/blocks.css' );

	//Custom JS
	wp_enqueue_script( 'ngo-charity-donation-custom.js', get_theme_file_uri( '/assets/js/theme-script.js' ), array( 'jquery' ), true );

	//Nav Focus JS
	wp_enqueue_script( 'ngo-charity-donation-navigation-focus', get_theme_file_uri( '/assets/js/navigation-focus.js' ), array( 'jquery' ), true );

	//Bootstarp JS
	wp_enqueue_script( 'bootstrap-js', get_theme_file_uri( '/assets/js/bootstrap.js' ), array( 'jquery' ),true );

	if ( is_singular() && comments_open() && get_option( 'thread_comments' ) ) {
		wp_enqueue_script( 'comment-reply' );
	}

	if (get_option('ngo_charity_donation_animation_enable', false) !== 'off') {
		//wow.js
		wp_enqueue_script( 'wow-js', get_theme_file_uri( '/assets/js/wow.js' ), array( 'jquery' ), true );

		//animate.css
		wp_enqueue_style( 'animate-css', get_template_directory_uri().'/assets/css/animate.css' );
	}
}
add_action( 'wp_enqueue_scripts', 'ngo_charity_donation_scripts' );

function ngo_charity_donation_block_editor_styles() {
	// Block styles.
	wp_enqueue_style( 'ngo-charity-donation-block-editor-style', trailingslashit( esc_url ( get_template_directory_uri() ) ) . '/assets/css/editor-blocks.css' );

	// Add custom fonts.
	wp_enqueue_style( 'ngo-charity-donation-fonts', ngo_charity_donation_fonts_url(), array() );
}
add_action( 'enqueue_block_editor_assets', 'ngo_charity_donation_block_editor_styles' );

# Load scripts and styles.(fontawesome)
add_action( 'customize_controls_enqueue_scripts', 'ngo_charity_donation_customize_controls_register_scripts' );

function ngo_charity_donation_customize_controls_register_scripts() {
	
	wp_enqueue_style( 'ngo-charity-donation-ctypo-customize-controls-style', trailingslashit( esc_url(get_template_directory_uri()) ) . '/assets/css/customize-controls.css' );
}

// enque files
require get_parent_theme_file_path( '/inc/custom-header.php' );
require get_parent_theme_file_path( '/inc/template-tags.php' );
require get_parent_theme_file_path( '/inc/template-functions.php' );
require get_parent_theme_file_path( '/inc/customizer.php' );
require get_parent_theme_file_path( '/inc/typofont.php' );
require get_parent_theme_file_path( '/inc/wptt-webfont-loader.php' );
require get_parent_theme_file_path( '/inc/breadcrumb.php' );
require_once get_template_directory() . '/inc/admin/welcome-notice.php';
require get_parent_theme_file_path( '/inc/sortable/sortable_control.php' );

add_action( 'admin_bar_menu', 'ngo_charity_donation_add_upgrade_button', 100 );

function ngo_charity_donation_add_upgrade_button( $ngo_charity_donation_wp_admin_bar ) {

    $ngo_charity_donation_theme_name = wp_get_theme()->get( 'Name' );

    $ngo_charity_donation_args = array(
        'id'    => 'ngo_charity_donation_upgrade',
        'title' => '<span style="color:#fff;font-weight:600;">
            🚀 Upgrade to ' . esc_html( $ngo_charity_donation_theme_name ) . ' Pro - 20% OFF 
            <span style="background:#ff5722;color:#fff;padding:2px 8px;border-radius:3px;margin-left:6px;">
                Buy Now
            </span>
        </span>',
        'href'  => esc_url( NGO_CHARITY_DONATION_BUY_PRO ),
        'meta'  => array(
            'class'  => 'ngo-charity-donation-upgrade-btn',
            'title'  => 'Upgrade to Pro',
            'target' => '_blank'
        )
    );

    $ngo_charity_donation_wp_admin_bar->add_node( $ngo_charity_donation_args );
}